
set serveroutput on
set echo on

CREATE OR REPLACE TYPE ot AS OBJECT (

  attr1 VARCHAR2(30)
, attr2 VARCHAR2(30)
, attr3 VARCHAR2(30)

, CONSTRUCTOR FUNCTION ot 
     RETURN SELF AS RESULT
);
/

CREATE TYPE BODY ot AS

   CONSTRUCTOR FUNCTION ot
      RETURN SELF AS RESULT IS
   BEGIN
      SELF.attr1 := 'X';
      SELF.attr2 := 'Y';
      SELF.attr3 := 'Z';
      RETURN;
   END;

END;
/

DECLARE
   o1 ot := ot('A','B','C');
   o2 ot := ot();
BEGIN
   DBMS_OUTPUT.PUT_LINE( 'o1.attr1 = [' || o1.attr1 || ']' );
   DBMS_OUTPUT.PUT_LINE( 'o2.attr1 = [' || o2.attr1 || ']' );
END;
/

