
set serveroutput on
set echo on

ALTER TYPE ot ADD 
   ATTRIBUTE (attr4 NUMBER,
              attr5 NUMBER)
   CASCADE;

DECLARE
   o1 ot := ot('A','B','C',1,2);
   o2 ot := ot();
   o3 ot := ot('F','G');
BEGIN
   DBMS_OUTPUT.PUT_LINE( 'o1.attr5 = [' || o1.attr5 || ']' );
   DBMS_OUTPUT.PUT_LINE( 'o2.attr5 = [' || o2.attr5 || ']' );
   DBMS_OUTPUT.PUT_LINE( 'o3.attr5 = [' || o3.attr5 || ']' );
END;
/

CREATE OR REPLACE TYPE BODY ot AS

   CONSTRUCTOR FUNCTION ot
      RETURN SELF AS RESULT IS
   BEGIN
      RETURN;
   END;

   CONSTRUCTOR FUNCTION ot ( p_attr1 IN VARCHAR2,
                             p_attr2 IN VARCHAR2 )
      RETURN SELF AS RESULT IS
   BEGIN
      SELF.attr1 := p_attr1;
      SELF.attr2 := p_attr2;
      SELF.attr3 := 'Z';
      SELF.attr4 := 100;
      SELF.attr5 := 200;
      RETURN;
   END;

END;
/

DECLARE
   o1 ot := ot();
   o2 ot := ot('F','G');
BEGIN
   DBMS_OUTPUT.PUT_LINE( 'o1.attr5 = [' || o1.attr5 || ']' );
   DBMS_OUTPUT.PUT_LINE( 'o2.attr5 = [' || o2.attr5 || ']' );
END;
/

