
set serveroutput on
set echo on

CREATE OR REPLACE TYPE ot AS OBJECT (

  attr1 VARCHAR2(30)
, attr2 VARCHAR2(30)
, attr3 VARCHAR2(30)

, CONSTRUCTOR FUNCTION ot
     RETURN SELF AS RESULT

, CONSTRUCTOR FUNCTION ot ( p_attr1 IN VARCHAR2,
                            p_attr2 IN VARCHAR2 )
     RETURN SELF AS RESULT
);
/

CREATE OR REPLACE TYPE BODY ot AS

   CONSTRUCTOR FUNCTION ot
      RETURN SELF AS RESULT IS
   BEGIN
      RETURN;
   END;

   CONSTRUCTOR FUNCTION ot ( p_attr1 IN VARCHAR2,
                             p_attr2 IN VARCHAR2 )
      RETURN SELF AS RESULT IS
   BEGIN
      SELF.attr1 := p_attr1;
      SELF.attr2 := p_attr2;
      SELF.attr3 := 'Z';
      RETURN;
   END;

END;
/

DECLARE
   o1 ot := ot('A','B','C');
   o2 ot := ot();
   o3 ot := ot('F','G');
BEGIN
   DBMS_OUTPUT.PUT_LINE( 'o1.attr1 = [' || o1.attr1 || ']' );
   DBMS_OUTPUT.PUT_LINE( 'o2.attr1 = [' || o2.attr1 || ']' );
   DBMS_OUTPUT.PUT_LINE( 'o3.attr1 = [' || o3.attr1 || ']' );
END;
/


