
set serveroutput on
set echo on

ALTER TYPE ot ADD 
   MEMBER FUNCTION print RETURN VARCHAR2
   CASCADE;

CREATE OR REPLACE TYPE BODY ot AS

   CONSTRUCTOR FUNCTION ot
      RETURN SELF AS RESULT IS
   BEGIN
      RETURN;
   END;

   CONSTRUCTOR FUNCTION ot ( p_attr1 IN VARCHAR2,
                             p_attr2 IN VARCHAR2,
                             p_attr5 IN NUMBER )
      RETURN SELF AS RESULT IS
   BEGIN
      SELF.attr1 := p_attr1;
      SELF.attr2 := p_attr2;
      SELF.attr3 := 'Z';
      SELF.attr4 := 100;
      SELF.attr5 := p_attr5;
      RETURN;
   END;

   MEMBER FUNCTION print RETURN VARCHAR2 IS
   BEGIN
      RETURN SELF.attr1          || '-' ||
             SELF.attr2          || '-' ||
             SELF.attr3          || '-' ||
             TO_CHAR(SELF.attr4) || '-' ||
             TO_CHAR(SELF.attr5);
   END;

END;
/

DECLARE
   o ot := ot('X','Y','Z',1,2);
BEGIN
   DBMS_OUTPUT.PUT_LINE( o.print() );
END;
/


