
set serveroutput on
set echo on

CREATE TABLE t
( number_column NUMBER
, object_column ot
);

INSERT INTO t
SELECT ROWNUM
,      ot(owner, name, type, line, length(text))
FROM   dba_source
WHERE  ROWNUM <= 5;

COMMIT;

SELECT * FROM t;

ALTER TYPE ot ADD 
   ATTRIBUTE (attr6 DATE)
   CASCADE INCLUDING TABLE DATA;

SELECT * FROM t;

conn scott

SELECT * FROM t;

col data_upgraded format a13

SELECT data_upgraded
FROM   user_tab_columns
WHERE  table_name = 'T'
AND    column_name = 'OBJECT_COLUMN';



