
set echo on

CREATE TYPE supertype_ot AS OBJECT
(  attr1 NUMBER,  
   MEMBER FUNCTION print RETURN VARCHAR2
)
NOT FINAL NOT INSTANTIABLE;
/

CREATE TYPE subtype_ot UNDER supertype_ot
(  attr2 DATE,  
   attr3 VARCHAR2(1),  
   OVERRIDING MEMBER FUNCTION print RETURN VARCHAR2
);
/

CREATE TYPE BODY subtype_ot AS

   OVERRIDING MEMBER FUNCTION print RETURN VARCHAR2 IS
   BEGIN
      RETURN '[SUBTYPE_OT] '     ||
             TO_CHAR(SELF.attr1) || ',' ||
             TO_CHAR(SELF.attr2) || ',' ||
             SELF.attr3;
   END;
END;
/

CREATE TYPE another_subtype_ot UNDER supertype_ot
(  attr2 NUMBER,
   attr3 NUMBER,
   attr4 NUMBER,
   OVERRIDING MEMBER FUNCTION print RETURN VARCHAR2
);
/

CREATE TYPE BODY another_subtype_ot AS

   OVERRIDING MEMBER FUNCTION print RETURN VARCHAR2 IS
   BEGIN
      RETURN '[ANOTHER_SUBTYPE_OT] ' ||
             TO_CHAR(SELF.attr1)     || ',' ||
             TO_CHAR(SELF.attr2)     || ',' ||
             TO_CHAR(SELF.attr3)     || ',' ||
             TO_CHAR(SELF.attr4);
   END;
END;
/


